<?php

/**
* Provides a microsummary for the latest forum posts.
* See <http://wiki.mozilla.org/Microsummaries> for details.
*
* Installation: Copy into the forum's public directory, i.e.
* /path/to/geeklog/public_html/forum/
*
* Author: Dirk Haun <dirk AT haun-online DOT de>
* released under the GNU General Public License v2
*
*/
require_once ('../lib-common.php');


/**
* This is the only thing you can configure in here:
* The format of the microsummary.
*
*/

define ('FORUM_MICROSUMMARY',
/* available variables:
 * {site_name}      - the site's name (from config.php)
 * {forum_name}     - name of the forum
 * {forum_label}    - same as the label in the site's header menu
 * {thread_title}   - subject of the current topic
 * anything else will just be printed verbatim
 */       
 '{forum_name}: {thread_title}'
);


/**
* don't touch anything below this line unless you know what you're doing
*/

$msg = '';
$forum = 0;
$subject = '';
$forum_name = '';

if ($CONF_FORUM['registration_required'] && (!isset ($_USER['uid']) || ($_USER['uid'] == 1))) {
    $msg = $LANG_GF02['msg01'];
}

if (isset ($_GET['forum'])) {
    $forum = COM_applyFilter ($_GET['forum'], true);
}

$groups = array ();
$usergroups = SEC_getUserGroups();
foreach ($usergroups as $group) {
    $groups[] = $group;
}
$groupAccessList = implode(',',$groups);

$f_sql = '';
if ($forum > 0) {
    $f_sql = "(forum_id = $forum) AND ";
}
$result = DB_query("SELECT forum_name FROM {$_TABLES['gf_forums']} WHERE " . $f_sql . "(is_hidden = 0) AND (no_newposts = 0) AND (grp_id IN ($groupAccessList))");
list($forum_name) = DB_fetchArray ($result);
if (!empty ($forum_name)) {
    $f_sql = '';
    if ($forum > 0) {
        $f_sql = "WHERE forum = $forum ";
    }
    $sql = "SELECT subject FROM {$_TABLES['gf_topic']} " . $f_sql . "ORDER BY date DESC LIMIT 1";
    $result = DB_query ($sql);
    list($subject) = DB_fetchArray ($result);
}

if (!empty ($subject)) {
    $msg = FORUM_MICROSUMMARY;
    $msg = str_replace ('{site_name}',
                        COM_undoSpecialChars ($_CONF['site_name']), $msg);
    $msg = str_replace ('{forum_name}',
                        COM_undoSpecialChars ($forum_name), $msg);
    $msg = str_replace ('{forum_label}',
                        COM_undoSpecialChars ($LANG_GF00['pluginlabel']), $msg);
    $msg = str_replace ('{thread_title}',
                        COM_undoSpecialChars ($subject), $msg);
}

if (empty ($msg)) {
    $msg = '(Forum or topic not found)';
}

header ('Content-Type: text/plain; charset=' . $LANG_CHARSET);
echo $msg;

?>
